<template>
    <v-container
        class="py-0"
        fluid
    >
        <v-row>
            <v-col class="pa-0 col-md-4">
                <v-select
                    class="dial-code"
                    v-model="dialObject"
                    :items="countryLookup"
                    item-text="name"
                    item-value="dialCode"
                    :cache-items="true"
                    :hide-details="hideDetails"
                    return-object
                    outlined
                >
                    <template slot="selection" slot-scope="data">
                        <span class="text-truncate d-inline-block">
                            {{ data.item.dialCode }}
                        </span>
                    </template>
                    <template slot="item" slot-scope="data">
                        {{ data.item.flag }} {{ data.item.name }} {{ data.item.dialCode }}
                    </template>
                </v-select>
            </v-col>
            <v-col class="pa-0">
                <v-text-field
                    class="phone"
                    v-model="phone"
                    :error-messages="errors"
                    :placeholder="placeholder"
                    :hide-details="hideDetails"
                    @keydown="numberOnly"
                    outlined
                ></v-text-field>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import util from "../../mixins/util";

    export default {
        name: "VTelInput",
        mixins: [ util ],
        props: {
            value: {
                type: String,
                required: true,
                default: ''
            },
            errors: [String, Array],
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: false
            },
            defaultCountry: {
                type: String,
                default: ''
            }
        },
        data: () => ({
            phone: '',
            dialObject: {
                countryCode: '',
                dialCode: ''
            }
        }),
        watch: {
            value() {
                if(this.value === '') {
                    this.phone = this.value;
                }
                else if(this.value && this.phone === '') {
                    const phone = this.parsePhone(this.value);
                    if(phone !== undefined) {
                        this.phone = phone.nationalNumber;
                        this.dialObject = this.countryLookup.find(c => c.countryCode === phone.country);
                    }
                    else {
                        this.phone = this.value;
                    }
                }
            },
            defaultCountry(val) {
                this.dialObject = this.countryLookup.find(c => c.countryCode === val);
            },
            dialObject: {
                handler(val) {
                    if(this.phone) {
                        const phone = this.normalizePhone(this.phone, val.countryCode);
                        this.$emit('input', phone);
                    }
                },
                deep: true
            },
            phone(val) {
                const phone = this.normalizePhone(val, this.dialObject.countryCode);
                this.$emit('input', phone);
            }
        },
        methods: {
            numberOnly(e) {
                let charCode = (e.which) ? e.which : e.keyCode;
                if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
                    e.preventDefault();
                } else {
                    return true;
                }
            }
        }
    }
</script>

<style scoped>
    .dial-code.v-text-field--outlined:not(.v-input--has-state):not(.v-input--is-focused):not(:hover) >>> fieldset {
        border-right: transparent;
    }
    .dial-code.v-text-field--outlined {
        border-radius: 4px 0 0 4px;
    }
    .phone.v-text-field--outlined {
        border-radius: 0 4px 4px 0;
    }
</style>
